#include <linux/compiler.h>
#include <linux/bitops.h>
#include <linux/bootmem.h>
#include <linux/bootmem_tools.h>
#include <linux/mmzone.h>
#include <linux/spinlock.h>

/* dump page table dump */
void dump_pt(unsigned long *ptr, char *s)
{
	int i;
	if (s)
	    printk("%s: 0x%08lx\n", s, (unsigned long)ptr);
	for (i = 0; i < 1024; ++i, ++ptr)
		if (*ptr)
			printk
			    ("%4u(%03x) : 0x%08lx / 0x%03lx\n",
			     i, i,
			     *ptr & ~(PAGE_SIZE - 1),
			     *ptr & ((1 << (10 + 1)) - 1));
}

void dump_pg0(void)
{
	dump_pt((unsigned long *) &pg0, "PG0");
}

void dump_pg1(void)
{
	dump_pt((unsigned long *) &pg0 + 1024, "PG1");
}

void dump_swapper_pg_dir(void)
{
	dump_pt((unsigned long *) &swapper_pg_dir, "swapper_pg_dir");
}
