#ifndef _RTAI_BOOTMEM_H
#define _RTAI_BOOTMEM_H

#include <rtai_config.h>

/* minimal and maximal extent size to use */
#define RTHEAP_MINEXTSIZE (16 * 1024)
#define RTHEAP_MAXEXTSIZE (128 * 1024)

/* leave at least RTHEAP_RESERVE bytes to kmalloc */
#define RTHEAP_RESERVE (CONFIG_RTAI_GHI_GREEDY_RESERVE * 1024)

#if defined(CONFIG_RTAI_GHI_GREEDY) || defined(CONFIG_RTAI_GHI_RUNTIME)
extern unsigned long rtai_global_heap_extentsize;

extern int rtai_ghi_greedy(rtheap_t * heap,
			   u_long pagesize,
			   u_long extentsize,
			   int *_heapsize);
#endif

#ifdef CONFIG_RTAI_GHI_RUNTIME
typedef enum {
    RTHEAP_GHI_TRADITIONAL,
    RTHEAP_GHI_GREEDY,
    RTHEAP_GHI_LARGEST
} rtheap_ghi_t;
#endif

#endif /* _RTAI_BOOTMEM_H */
