#ifndef _RTAI_CONFIG_H
#define _RTAI_CONFIG_H

#include <linux/config.h>
//#include <linux/compile.h>

#define CONFIG_RTAI_VERSION_MAJOR 3
#define CONFIG_RTAI_VERSION_MINOR 4
#define CONFIG_RTAI_REVISION_LEVEL 0
#define PACKAGE_VERSION CONFIG_RTAI_VERSION
#define CONFIG_KBUILD 1
#define CONFIG_RTAI 1
#define CONFIG_LRTAI 1
#define CONFIG_RTAI_IPIPE 1
#define CONFIG_RTAI_COMPILER "Unknown compiler"
#define CONFIG_RTAI_INTERNAL_LXRT_INLINE 2
#define CONFIG_RTAI_IMMEDIATE_LINUX_SYSCALL 1
#define CONFIG_RTAI_INTERNAL_LXRT_SUPPORT 1
#define CONFIG_RTAI_MONITOR_EXECTIME 1
#undef CONFIG_RTAI_MALLOC_BUILTIN
/* legacy */
#define CONFIG_RTAI_MOUNT_ON_LOAD 1

//#define CONFIG_RTAI_BUILD_STRING "i386-pc-linux-gnu"
//#define CONFIG_RTAI_HOST_STRING "i386-pc-linux-gnu"

#ifndef CONFIG_RTAI_LXRT_INLINE
#define CONFIG_RTAI_LXRT_INLINE CONFIG_RTAI_INTERNAL_LXRT_INLINE
#endif /* !CONFIG_RTAI_LXRT_INLINE */
#define __hidefun(name) name ## _hidden_inline
#if CONFIG_RTAI_LXRT_INLINE == 1
#define RTAI_PROTO(type,name,arglist) static inline type name arglist
#elif CONFIG_RTAI_LXRT_INLINE == 2
#define RTAI_PROTO(type,name,arglist) extern inline type name arglist
#elif CONFIG_RTAI_LXRT_INLINE == 3
#define RTAI_PROTO(type,name,arglist) type name arglist; static inline type __hidefun(name) arglist
#else
#define RTAI_PROTO(type,name,arglist) type name arglist
#endif /* CONFIG_RTAI_LXRT_INLINE */
#define RTAI_PROTO_ALWAYS_INLINE(type,name,arglist) static inline type name arglist
#define RTAI_PROTO_NEVER_INLINE(type,name,arglist) type name arglist; static inline type __hidefun(name) arglist

#ifdef CONFIG_RTAI_FPU_SUPPORT
#undef CONFIG_RTAI_FPU_SUPPORT
#define CONFIG_RTAI_FPU_SUPPORT 1
#else
#undef CONFIG_RTAI_FPU_SUPPORT
#define CONFIG_RTAI_FPU_SUPPORT 0
#endif

#ifdef CONFIG_RTAI_USE_NEWERR
#undef CONFIG_RTAI_USE_NEWERR
#define CONFIG_RTAI_USE_NEWERR 1
#else
#undef CONFIG_RTAI_USE_NEWERR
#define CONFIG_RTAI_USE_NEWERR 0
#endif

#ifdef CONFIG_RTAI_ONE_SHOT
#undef CONFIG_RTAI_ONE_SHOT
#define CONFIG_RTAI_ONE_SHOT 1
#else
#undef CONFIG_RTAI_ONE_SHOT
#define CONFIG_RTAI_ONE_SHOT 0
#endif

#ifdef CONFIG_RTAI_BUSY_TIME_ALIGN
#undef CONFIG_RTAI_BUSY_TIME_ALIGN
#define CONFIG_RTAI_BUSY_TIME_ALIGN 1
#else
#undef CONFIG_RTAI_BUSY_TIME_ALIGN
#define CONFIG_RTAI_BUSY_TIME_ALIGN 0
#endif

#endif /* !_RTAI_CONFIG_H */
